Loading...
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
5PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
6 localmodconfig localyesconfig
7
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
11Kconfig := Kconfig
12endif
13
14ifeq ($(quiet),silent_)
15silent := -s
16endif
17
18# We need this, in case the user has it in its environment
19unexport CONFIG_
20
21xconfig: $(obj)/qconf
22 $< $(silent) $(Kconfig)
23
24gconfig: $(obj)/gconf
25 $< $(silent) $(Kconfig)
26
27menuconfig: $(obj)/mconf
28 $< $(silent) $(Kconfig)
29
30config: $(obj)/conf
31 $< $(silent) --oldaskconfig $(Kconfig)
32
33nconfig: $(obj)/nconf
34 $< $(silent) $(Kconfig)
35
36silentoldconfig: $(obj)/conf
37 $(Q)mkdir -p include/config include/generated
38 $< $(silent) --$@ $(Kconfig)
39
40localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
41 $(Q)mkdir -p include/config include/generated
42 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
43 $(Q)if [ -f .config ]; then \
44 cmp -s .tmp.config .config || \
45 (mv -f .config .config.old.1; \
46 mv -f .tmp.config .config; \
47 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
48 mv -f .config.old.1 .config.old) \
49 else \
50 mv -f .tmp.config .config; \
51 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
52 fi
53 $(Q)rm -f .tmp.config
54
55# Create new linux.pot file
56# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
57update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
58 $(Q)$(kecho) " GEN config.pot"
59 $(Q)xgettext --default-domain=linux \
60 --add-comments --keyword=_ --keyword=N_ \
61 --from-code=UTF-8 \
62 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
63 --directory=$(srctree) --directory=$(objtree) \
64 --output $(obj)/config.pot
65 $(Q)sed -i s/CHARSET/UTF-8 $(obj)/config.pot
66 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
67 $(srctree)/arch/*/um/Kconfig`; \
68 do \
69 $(kecho) " GEN $$i"; \
70 $(obj)/kxgettext $$i \
71 >> $(obj)/config.pot; \
72 done )
73 $(Q)$(kecho) " GEN linux.pot"
74 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
75 --output $(obj)/linux.pot
76 $(Q)rm -f $(obj)/config.pot
77
78# These targets map 1:1 to the commandline options of 'conf'
79simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
80 alldefconfig randconfig listnewconfig olddefconfig
81PHONY += $(simple-targets)
82
83$(simple-targets): $(obj)/conf
84 $< $(silent) --$@ $(Kconfig)
85
86PHONY += oldnoconfig savedefconfig defconfig
87
88# oldnoconfig is an alias of olddefconfig, because people already are dependent
89# on its behavior (sets new symbols to their default value but not 'n') with the
90# counter-intuitive name.
91oldnoconfig: olddefconfig
92
93savedefconfig: $(obj)/conf
94 $< $(silent) --$@=defconfig $(Kconfig)
95
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
98 $< $(silent) --defconfig $(Kconfig)
99else
100ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
101 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
102 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
103else
104 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
105 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
106endif
107endif
108
109%_defconfig: $(obj)/conf
110 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
111
112configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
113
114%.config: $(obj)/conf
115 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
116 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
117 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
118
119PHONY += kvmconfig
120kvmconfig: kvm_guest.config
121 @:
122
123PHONY += xenconfig
124xenconfig: xen.config
125 @:
126
127PHONY += tinyconfig
128tinyconfig:
129 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
130
131# Help text used by make help
132help:
133 @echo ' config - Update current config utilising a line-oriented program'
134 @echo ' nconfig - Update current config utilising a ncurses menu based'
135 @echo ' program'
136 @echo ' menuconfig - Update current config utilising a menu based program'
137 @echo ' xconfig - Update current config utilising a Qt based front-end'
138 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
139 @echo ' oldconfig - Update current config utilising a provided .config as base'
140 @echo ' localmodconfig - Update current config disabling modules not loaded'
141 @echo ' localyesconfig - Update current config converting local mods to core'
142 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
143 @echo ' defconfig - New config with default from ARCH supplied defconfig'
144 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
145 @echo ' allnoconfig - New config where all options are answered with no'
146 @echo ' allyesconfig - New config where all options are accepted with yes'
147 @echo ' allmodconfig - New config selecting modules when possible'
148 @echo ' alldefconfig - New config with all symbols set to default'
149 @echo ' randconfig - New config with random answer to all options'
150 @echo ' listnewconfig - List new options'
151 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their'
152 @echo ' default value'
153 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
154 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
155 @echo ' tinyconfig - Configure the tiniest possible kernel'
156
157# lxdialog stuff
158check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
159
160# Use recursively expanded variables so we do not call gcc unless
161# we really need to do so. (Do not call gcc as part of make mrproper)
162HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
163 -DLOCALE
164
165# ===========================================================================
166# Shared Makefile for the various kconfig executables:
167# conf: Used for defconfig, oldconfig and related targets
168# nconf: Used for the nconfig target.
169# Utilizes ncurses
170# mconf: Used for the menuconfig target
171# Utilizes the lxdialog package
172# qconf: Used for the xconfig target
173# Based on Qt which needs to be installed to compile it
174# gconf: Used for the gconfig target
175# Based on GTK+ which needs to be installed to compile it
176# object files used by all kconfig flavours
177
178lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
179lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
180
181conf-objs := conf.o zconf.tab.o
182mconf-objs := mconf.o zconf.tab.o $(lxdialog)
183nconf-objs := nconf.o zconf.tab.o nconf.gui.o
184kxgettext-objs := kxgettext.o zconf.tab.o
185qconf-cxxobjs := qconf.o
186qconf-objs := zconf.tab.o
187gconf-objs := gconf.o zconf.tab.o
188
189hostprogs-y := conf nconf mconf kxgettext qconf gconf
190
191clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
192clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
193clean-files += config.pot linux.pot
194
195# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
196PHONY += $(obj)/dochecklxdialog
197$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
198$(obj)/dochecklxdialog:
199 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
200
201always := dochecklxdialog
202
203# Add environment specific flags
204HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
205
206# generated files seem to need this to find local include files
207HOSTCFLAGS_zconf.lex.o := -I$(src)
208HOSTCFLAGS_zconf.tab.o := -I$(src)
209
210LEX_PREFIX_zconf := zconf
211YACC_PREFIX_zconf := zconf
212
213HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
214HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
215
216HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
217HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
218 -Wno-missing-prototypes
219
220HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
221
222HOSTLOADLIBES_nconf = $(shell \
223 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
224 || pkg-config --libs menu panel ncurses 2>/dev/null \
225 || echo "-lmenu -lpanel -lncurses" )
226$(obj)/qconf.o: $(obj)/.tmp_qtcheck
227
228ifeq ($(MAKECMDGOALS),xconfig)
229$(obj)/.tmp_qtcheck: $(src)/Makefile
230-include $(obj)/.tmp_qtcheck
231
232# Qt needs some extra effort...
233$(obj)/.tmp_qtcheck:
234 @set -e; $(kecho) " CHECK qt"; \
235 if pkg-config --exists Qt5Core; then \
236 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
237 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
238 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
239 elif pkg-config --exists QtCore; then \
240 cflags=`pkg-config --cflags QtCore QtGui`; \
241 libs=`pkg-config --libs QtCore QtGui`; \
242 moc=`pkg-config --variable=moc_location QtCore`; \
243 else \
244 echo >&2 "*"; \
245 echo >&2 "* Could not find Qt via pkg-config."; \
246 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
247 echo >&2 "*"; \
248 exit 1; \
249 fi; \
250 echo "KC_QT_CFLAGS=$$cflags" > $@; \
251 echo "KC_QT_LIBS=$$libs" >> $@; \
252 echo "KC_QT_MOC=$$moc" >> $@
253endif
254
255$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
256
257ifeq ($(MAKECMDGOALS),gconfig)
258-include $(obj)/.tmp_gtkcheck
259
260# GTK+ needs some extra effort, too...
261$(obj)/.tmp_gtkcheck:
262 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
263 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
264 touch $@; \
265 else \
266 echo >&2 "*"; \
267 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
268 echo >&2 "*"; \
269 false; \
270 fi \
271 else \
272 echo >&2 "*"; \
273 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
274 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
275 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
276 echo >&2 "*"; \
277 false; \
278 fi
279endif
280
281$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
282
283$(obj)/qconf.o: $(obj)/qconf.moc
284
285quiet_cmd_moc = MOC $@
286 cmd_moc = $(KC_QT_MOC) -i $< -o $@
287
288$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
289 $(call cmd,moc)
290
291# Extract gconf menu items for i18n support
292$(obj)/gconf.glade.h: $(obj)/gconf.glade
293 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
294 $(obj)/gconf.glade
1# SPDX-License-Identifier: GPL-2.0
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
6ifdef KBUILD_KCONFIG
7Kconfig := $(KBUILD_KCONFIG)
8else
9Kconfig := Kconfig
10endif
11
12ifndef KBUILD_DEFCONFIG
13KBUILD_DEFCONFIG := defconfig
14endif
15
16ifeq ($(quiet),silent_)
17silent := -s
18endif
19
20export KCONFIG_DEFCONFIG_LIST :=
21ifndef cross_compiling
22kernel-release := $(shell uname -r)
23KCONFIG_DEFCONFIG_LIST += \
24 /lib/modules/$(kernel-release)/.config \
25 /etc/kernel-config \
26 /boot/config-$(kernel-release)
27endif
28KCONFIG_DEFCONFIG_LIST += arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)
29
30# We need this, in case the user has it in its environment
31unexport CONFIG_
32
33config-prog := conf
34menuconfig-prog := mconf
35nconfig-prog := nconf
36gconfig-prog := gconf
37xconfig-prog := qconf
38
39define config_rule
40PHONY += $(1)
41$(1): $(obj)/$($(1)-prog)
42 $(Q)$$< $(silent) $(Kconfig)
43
44PHONY += build_$(1)
45build_$(1): $(obj)/$($(1)-prog)
46endef
47
48$(foreach c, config menuconfig nconfig gconfig xconfig, $(eval $(call config_rule,$(c))))
49
50PHONY += localmodconfig localyesconfig
51localyesconfig localmodconfig: $(obj)/conf
52 $(Q)$(PERL) $(srctree)/$(src)/streamline_config.pl --$@ $(srctree) $(Kconfig) > .tmp.config
53 $(Q)if [ -f .config ]; then \
54 cmp -s .tmp.config .config || \
55 (mv -f .config .config.old.1; \
56 mv -f .tmp.config .config; \
57 $< $(silent) --oldconfig $(Kconfig); \
58 mv -f .config.old.1 .config.old) \
59 else \
60 mv -f .tmp.config .config; \
61 $< $(silent) --oldconfig $(Kconfig); \
62 fi
63 $(Q)rm -f .tmp.config
64
65# These targets map 1:1 to the commandline options of 'conf'
66#
67# Note:
68# syncconfig has become an internal implementation detail and is now
69# deprecated for external use
70simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
71 alldefconfig randconfig listnewconfig olddefconfig syncconfig \
72 helpnewconfig yes2modconfig mod2yesconfig mod2noconfig
73
74PHONY += $(simple-targets)
75
76$(simple-targets): $(obj)/conf
77 $(Q)$< $(silent) --$@ $(Kconfig)
78
79PHONY += savedefconfig defconfig
80
81savedefconfig: $(obj)/conf
82 $(Q)$< $(silent) --$@=defconfig $(Kconfig)
83
84defconfig: $(obj)/conf
85ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
86 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
87 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
88else
89 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
90 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
91endif
92
93%_defconfig: $(obj)/conf
94 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
95
96configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
97
98%.config: $(obj)/conf
99 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
100 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
101 $(Q)$(MAKE) -f $(srctree)/Makefile olddefconfig
102
103PHONY += tinyconfig
104tinyconfig:
105 $(Q)KCONFIG_ALLCONFIG=kernel/configs/tiny-base.config $(MAKE) -f $(srctree)/Makefile allnoconfig
106 $(Q)$(MAKE) -f $(srctree)/Makefile tiny.config
107
108# CHECK: -o cache_dir=<path> working?
109PHONY += testconfig
110testconfig: $(obj)/conf
111 $(Q)$(PYTHON3) -B -m pytest $(srctree)/$(src)/tests \
112 -o cache_dir=$(abspath $(obj)/tests/.cache) \
113 $(if $(findstring 1,$(KBUILD_VERBOSE)),--capture=no)
114clean-files += tests/.cache
115
116# Help text used by make help
117help:
118 @echo ' config - Update current config utilising a line-oriented program'
119 @echo ' nconfig - Update current config utilising a ncurses menu based program'
120 @echo ' menuconfig - Update current config utilising a menu based program'
121 @echo ' xconfig - Update current config utilising a Qt based front-end'
122 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
123 @echo ' oldconfig - Update current config utilising a provided .config as base'
124 @echo ' localmodconfig - Update current config disabling modules not loaded'
125 @echo ' except those preserved by LMC_KEEP environment variable'
126 @echo ' localyesconfig - Update current config converting local mods to core'
127 @echo ' except those preserved by LMC_KEEP environment variable'
128 @echo ' defconfig - New config with default from ARCH supplied defconfig'
129 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
130 @echo ' allnoconfig - New config where all options are answered with no'
131 @echo ' allyesconfig - New config where all options are accepted with yes'
132 @echo ' allmodconfig - New config selecting modules when possible'
133 @echo ' alldefconfig - New config with all symbols set to default'
134 @echo ' randconfig - New config with random answer to all options'
135 @echo ' yes2modconfig - Change answers from yes to mod if possible'
136 @echo ' mod2yesconfig - Change answers from mod to yes if possible'
137 @echo ' mod2noconfig - Change answers from mod to no if possible'
138 @echo ' listnewconfig - List new options'
139 @echo ' helpnewconfig - List new options and help text'
140 @echo ' olddefconfig - Same as oldconfig but sets new symbols to their'
141 @echo ' default value without prompting'
142 @echo ' tinyconfig - Configure the tiniest possible kernel'
143 @echo ' testconfig - Run Kconfig unit tests (requires python3 and pytest)'
144
145# ===========================================================================
146# object files used by all kconfig flavours
147common-objs := confdata.o expr.o lexer.lex.o menu.o parser.tab.o \
148 preprocess.o symbol.o util.o
149
150$(obj)/lexer.lex.o: $(obj)/parser.tab.h
151HOSTCFLAGS_lexer.lex.o := -I $(srctree)/$(src)
152HOSTCFLAGS_parser.tab.o := -I $(srctree)/$(src)
153
154# conf: Used for defconfig, oldconfig and related targets
155hostprogs += conf
156conf-objs := conf.o $(common-objs)
157
158# nconf: Used for the nconfig target based on ncurses
159hostprogs += nconf
160nconf-objs := nconf.o nconf.gui.o $(common-objs)
161
162HOSTLDLIBS_nconf = $(call read-file, $(obj)/nconf-libs)
163HOSTCFLAGS_nconf.o = $(call read-file, $(obj)/nconf-cflags)
164HOSTCFLAGS_nconf.gui.o = $(call read-file, $(obj)/nconf-cflags)
165
166$(obj)/nconf: | $(obj)/nconf-libs
167$(obj)/nconf.o $(obj)/nconf.gui.o: | $(obj)/nconf-cflags
168
169# mconf: Used for the menuconfig target based on lxdialog
170hostprogs += mconf
171lxdialog := $(addprefix lxdialog/, \
172 checklist.o inputbox.o menubox.o textbox.o util.o yesno.o)
173mconf-objs := mconf.o $(lxdialog) $(common-objs)
174
175HOSTLDLIBS_mconf = $(call read-file, $(obj)/mconf-libs)
176$(foreach f, mconf.o $(lxdialog), \
177 $(eval HOSTCFLAGS_$f = $$(call read-file, $(obj)/mconf-cflags)))
178
179$(obj)/mconf: | $(obj)/mconf-libs
180$(addprefix $(obj)/, mconf.o $(lxdialog)): | $(obj)/mconf-cflags
181
182# qconf: Used for the xconfig target based on Qt
183hostprogs += qconf
184qconf-cxxobjs := qconf.o qconf-moc.o
185qconf-objs := images.o $(common-objs)
186
187HOSTLDLIBS_qconf = $(call read-file, $(obj)/qconf-libs)
188HOSTCXXFLAGS_qconf.o = -std=c++11 -fPIC $(call read-file, $(obj)/qconf-cflags)
189HOSTCXXFLAGS_qconf-moc.o = -std=c++11 -fPIC $(call read-file, $(obj)/qconf-cflags)
190$(obj)/qconf: | $(obj)/qconf-libs
191$(obj)/qconf.o $(obj)/qconf-moc.o: | $(obj)/qconf-cflags
192
193quiet_cmd_moc = MOC $@
194 cmd_moc = $(call read-file, $(obj)/qconf-bin)/moc $< -o $@
195
196$(obj)/qconf-moc.cc: $(src)/qconf.h FORCE | $(obj)/qconf-bin
197 $(call if_changed,moc)
198
199targets += qconf-moc.cc
200
201# gconf: Used for the gconfig target based on GTK+
202hostprogs += gconf
203gconf-objs := gconf.o images.o $(common-objs)
204
205HOSTLDLIBS_gconf = $(call read-file, $(obj)/gconf-libs)
206HOSTCFLAGS_gconf.o = $(call read-file, $(obj)/gconf-cflags)
207
208$(obj)/gconf: | $(obj)/gconf-libs
209$(obj)/gconf.o: | $(obj)/gconf-cflags
210
211# check if necessary packages are available, and configure build flags
212cmd_conf_cfg = $< $(addprefix $(obj)/$*conf-, cflags libs bin); touch $(obj)/$*conf-bin
213
214$(obj)/%conf-cflags $(obj)/%conf-libs $(obj)/%conf-bin: $(src)/%conf-cfg.sh
215 $(call cmd,conf_cfg)
216
217clean-files += *conf-cflags *conf-libs *conf-bin